      PROGRAM GSC
C
C              MAIN PROGRAM GSC
C
C    COMPUTING PROBABILITY FOR GIVEN PARAMETERS AND PARAMETERS
C    FOR GIVEN PROBABILITY OF WIENER PROCESS, BROWNIAN BRIDGE
C    PROCESS.
C
C               GSC PAPER 87-12
C
C            C. F. CHUNG, GEOLOGICAL SURVEY OF CANADA.
C
      COMMON /FUNCT/DELTA(10)
C
      WRITE(*,999)' THIS PROGRAM HAS BEEN DEVELOPED AT THE '
      WRITE(*,999)'      GEOLOGICAL SURVEY OF CANADA.'
      WRITE(*,999)
10    WRITE(*,999)'  THE FOLLOWING OPTIONS ARE AVAILABLE:'
      WRITE(*,999)'  1 : COMPUTE PROBABILITY OF A WIENER  PROCESS'
      WRITE(*,999)'  2 : COMPUTE PROBABILITY OF A BROWNIAN BRIDGE'
      WRITE(*,999)'  3 : GIVEN PROBABILITY LEVEL, COMPUTE PARAMETER'
      WRITE(*,999)'            SELECTED OF A WIENER PROCESS'
      WRITE(*,999)'  4 : GIVEN PROBABILITY LEVEL, COMPUTE PARAMETER'
      WRITE(*,999)'            SELECTED OF A BROWNIAN BRIDGE'
      WRITE(*,999)'  5 : STOP.'
      WRITE(*,999)
20    WRITE(*,999)' ENTER OPTION (1-5)'
      READ(*,998)ISEL
999   FORMAT(A)
998   FORMAT(I1)
      IF(ISEL.LT.0.OR.ISEL.GT.5)GO TO 20
      GOTO (110,120,130,140,150),ISEL
110   CALL WWIN
      GO TO 10
120   CALL BBIN
      GO TO 10
130   CALL INWW
      GO TO 10
140   CALL INBB
      GO TO 10
150   STOP
      END
C==========================================================
C
      SUBROUTINE WWIN
C
C CALLING FOR COMPUTING PROBABILITY OF WIENER PROCESS
C
      CHARACTER IYES*1,ANSWER*1
      DATA IYES/'Y'/
10    WRITE(*,999)' ENTER 0 FOR P = PROB{    W(T)<C : A<T<B }'
      WRITE(*,999)'               OR'
      WRITE(*,999)' ENTER 1 FOR P = PROB{ -C<W(T)<C : A<T<B }'
      READ(*,998)INN
      WRITE(*,999)' ENTER  C  ( > 0 ) , C = '
      READ(*,997)C
      WRITE(*,999)' ENTER  A  ( >=0 ) , A = '
      READ(*,997)A
      WRITE(*,999)' ENTER  B  ( > A ) , B = '
      READ(*,997)B
C
999   FORMAT(A)
998   FORMAT(I1)
997   FORMAT(F12.0)
996   FORMAT(A,I3)
995   FORMAT(A,F12.6)
994   FORMAT(A1)
      IF ( INN.EQ.0 ) THEN
        CALL WWPR( A,B,C,PROB,IER )
      ELSE
        CALL WWAS( A,B,C,PROB,IER )
      ENDIF
C
      IF ( IER.NE.0 ) THEN
        WRITE(*,996)' ERROR OCCURS, ERROR NUMBER = ',IER
      ELSE
        WRITE(*,995) ' GIVEN PARAMETERS, PROBABILITY = ',PROB
      ENDIF
      WRITE(*,999)' WOULD YOU LIKE TO TRY ANOTHER PARAMETERS?(Y OR N)'
      READ(*,994)ANSWER
      IF( ANSWER.EQ.IYES ) GO TO 10
      RETURN
      END
C==========================================================
C
      SUBROUTINE BBIN
C
C CALLING FOR COMPUTING PROBABILITY OF BROWIAN BRIDGE PROCESS
C
      CHARACTER IYES*1,ANSWER*1
      DATA IYES/'Y'/
10    WRITE(*,999)' ENTER 0 FOR P = PROB{    B(T)<C : A<T<B }'
      WRITE(*,999)'               OR'
      WRITE(*,999)' ENTER 1 FOR P = PROB{ -C<B(T)<C : A<T<B }'
      READ(*,998)INN
      WRITE(*,999)' ENTER  C  (   > 0   ) , C = '
      READ(*,997)C
      WRITE(*,999)' ENTER  A  ( 0<=A< B ) , A = '
      READ(*,997)A
      WRITE(*,999)' ENTER  B  ( A< B<=1 ) , B = '
      READ(*,997)B
C
999   FORMAT(A)
998   FORMAT(I1)
997   FORMAT(F12.0)
996   FORMAT(A,I3)
995   FORMAT(A,F12.6)
994   FORMAT(A1)
      IF ( INN.EQ.0 ) THEN
        CALL BBPR( A,B,C,PROB,IER )
      ELSE
        CALL BBAS( A,B,C,PROB,IER )
      ENDIF
C
      IF ( IER.NE.0 ) THEN
        WRITE(*,996)' ERROR OCCURS, ERROR NUMBER = ',IER
      ELSE
        WRITE(*,995) ' GIVEN PARAMETERS, PROBABILITY = ',PROB
      ENDIF
      WRITE(*,999)' WOULD YOU LIKE TO TRY ANOTHER PARAMETERS?(Y OR N)'
      READ(*,995)ANSWER
      IF( ANSWER.EQ.IYES ) GO TO 10
      RETURN
      END
C==========================================================
C
      SUBROUTINE INWW
C
C CALLING FOR COMPUTING PARAMETER OF WIENER PROCESS, FOR
C GIVEN PROBABILITY LEVEL
C
      CHARACTER IYES*1,ANSWER*1
      DATA IYES/'Y'/
10    WRITE(*,999)' ENTER 0 FOR P = PROB{    W(T)<C : A<T<B }'
      WRITE(*,999)'               OR'
      WRITE(*,999)' ENTER 1 FOR P = PROB{ -C<W(T)<C : A<T<B }'
      WRITE(*,999)'               OR'
      WRITE(*,999)' ENTER 2 FOR P = PROB{ W(T)<C+DT : A<T<B }'
      WRITE(*,999)'               OR'
      WRITE(*,999)' ENTER 3 FOR P = P{-C-DT<W(T)<C+DT:A<T<B }'
      READ(*,998)INN
C
999   FORMAT(A)
998   FORMAT(I1)
997   FORMAT(F12.0)
996   FORMAT(A,I3)
995   FORMAT(A,F12.6)
994   FORMAT(A1)
      IF ( INN.EQ.0 ) THEN
        WRITE(*,999)' TO CALCULATE  C , ENTER OPTION = 1'
        WRITE(*,999)'               A                  2'
        WRITE(*,999)'               B                  3'
        WRITE(*,999)'  OPTION = '
      ENDIF
      IF ( INN.EQ.1 ) THEN
        WRITE(*,999)' TO CALCULATE  C , ENTER OPTION = 4'
        WRITE(*,999)'               A                  5'
        WRITE(*,999)'               B                  6'
        WRITE(*,999)'  OPTION = '
      ENDIF
      IF ( INN.EQ.2 ) THEN
        WRITE(*,999)' TO CALCULATE  C , ENTER OPTION = 7'
        WRITE(*,999)'               D                  8'
        WRITE(*,999)'  OPTION = '
      ENDIF
      IF ( INN.EQ.3 ) THEN
        WRITE(*,999)' TO CALCULATE  C , ENTER OPTION = 9'
        WRITE(*,999)'               D                  10'
        WRITE(*,999)'  OPTION = '
      ENDIF
      READ(*,998)IOP
      WRITE(*,999)' ENTER  P  ( 0<P<1 ) , P = '
      READ(*,997)P
      IF ( IOP.EQ.1.OR.IOP.EQ.4.OR.IOP.GE.7 ) THEN
        WRITE(*,999)' ENTER  A  ( >=0 ) , A = '
        READ(*,997)A
        WRITE(*,999)' ENTER  B  ( > A ) , B = '
        READ(*,997)B
        IF (IOP.EQ.7.OR.IOP.EQ.9) THEN
          WRITE(*,999)' ENTER  D , D = '
          READ(*,997)D
        ELSE
          WRITE(*,999)' ENTER  C , C = '
          READ(*,997)C
        ENDIF
      ELSE
        IF ( IOP.EQ.2.OR.IOP.EQ.5 ) THEN
          WRITE(*,999)' ENTER  C  ( > 0 ) , C = '
          READ(*,997)C
          WRITE(*,999)' ENTER  B  ( > A ) , B = '
          READ(*,997)B
        ELSE
          WRITE(*,999)' ENTER  C  ( > 0 ) , C = '
          READ(*,997)C
          WRITE(*,999)' ENTER  A  ( >=0 ) , A = '
          READ(*,997)A
        ENDIF
      ENDIF
C
      CALL INVWW( A,B,C,D,P,IOP,IER )
C
      IF ( IER.NE.0 ) THEN
        WRITE(*,996)' ERROR OCCURS, ERROR NUMBER = ',IER
      ELSE 
        IF ( IOP.EQ.1.OR.IOP.EQ.4.OR.IOP.EQ.7.OR.IOP.EQ.9 ) THEN
          PARA = C
        ELSE
          IF ( IOP.EQ.2.OR.IOP.EQ.5 ) THEN
            PARA = A
          ELSE
            IF ( IOP.EQ.3.OR.IOP.EQ.6 ) THEN
              PARA = B
            ELSE
              PARA = D
            ENDIF
          ENDIF
        ENDIF
        WRITE(*,995) ' GIVEN PROBABILITY, PARAMETER = ',PARA
      ENDIF
      WRITE(*,999)' WOULD YOU LIKE TO TRY ANOTHER PARAMETERS?(Y OR N)'
      READ(*,994)ANSWER
      IF( ANSWER.EQ.IYES ) GO TO 10
      RETURN
      END
C==========================================================
C
      SUBROUTINE INBB
C
C CALLING FOR COMPUTING PARAMETER OF BROWNIAN BRIDGE PROCESS,
C FOR GIVEN PROBABILITY LEVEL
C
      CHARACTER IYES*1,ANSWER*1
      DATA IYES/'Y'/
10    WRITE(*,999)' ENTER 0 FOR P = PROB{    B(T)<C : A<T<B }'
      WRITE(*,999)'               OR'
      WRITE(*,999)' ENTER 1 FOR P = PROB{ -C<B(T)<C : A<T<B }'
      READ(*,998)INN
C
999   FORMAT(A)
998   FORMAT(I1)
997   FORMAT(F12.0)
996   FORMAT(A,I3)
995   FORMAT(A,F12.6)
994   FORMAT(A1)
      IF ( INN.EQ.0 ) THEN
        WRITE(*,999)' TO CALCULATE  C , ENTER OPTION = 1'
        WRITE(*,999)'               A                  2'
        WRITE(*,999)'               B                  3'
        WRITE(*,999)'  OPTION = '
      ELSE
        WRITE(*,999)' TO CALCULATE  C , ENTER OPTION = 4'
        WRITE(*,999)'               A                  5'
        WRITE(*,999)'               B                  6'
        WRITE(*,999)'  OPTION = '
      ENDIF
      READ(*,998)IOP
      WRITE(*,999)' ENTER  P  ( 0<P<1 ) , P = '
      READ(*,997)P
      IF ( IOP.EQ.1.OR.IOP.EQ.4) THEN
        WRITE(*,999)' ENTER  A  ( >=0 ) , A = '
        READ(*,997)A
        WRITE(*,999)' ENTER  B  ( > A ) , B = '
        READ(*,997)B
      ELSE
        IF ( IOP.EQ.2.OR.IOP.EQ.5 ) THEN
          WRITE(*,999)' ENTER  C  ( > 0 ) , C = '
          READ(*,997)C
          WRITE(*,999)' ENTER  B  ( > A ) , B = '
          READ(*,997)B
        ELSE
          WRITE(*,999)' ENTER  C  ( > 0 ) , C = '
          READ(*,997)C
          WRITE(*,999)' ENTER  A  ( >=0 ) , A = '
          READ(*,997)A
        ENDIF
      ENDIF
C
      CALL INVBB( A,B,C,P,IOP,IER )
C
      IF ( IER.NE.0 ) THEN
        WRITE(*,996)' ERROR OCCURS, ERROR NUMBER = ',IER
      ELSE 
        IF ( IOP.EQ.1.OR.IOP.EQ.4 ) THEN
          PARA = C
        ELSE
          IF ( IOP.EQ.2.OR.IOP.EQ.5 ) THEN
            PARA = A
          ELSE
            PARA = B
          ENDIF
        ENDIF
        WRITE(*,995) ' GIVEN PROBABILITY, PARAMETER = ',PARA
      ENDIF
      WRITE(*,999)' WOULD YOU LIKE TO TRY ANOTHER PARAMETERS?(Y OR N)'
      READ(*,994)ANSWER
      IF( ANSWER.EQ.IYES ) GO TO 10
      RETURN
      END
C==========================================================
C
      SUBROUTINE FLOW ( UFLOW,OFLOW )
C**********************************************************
C
C  THIS ROUTINE PROVIDES THE MACHINE CONSTANTS OF THE
C  SMALLEST AND LARGEST NUMBERS.
C
C  PARAMETERS:
C    OUT   UFLOW  :  THE SMALLEST POSITIVE NUMBER
C          OFLOW  :  THE LARGEST  POSITIVE NUMBER
C
C**********************************************************
      UFLOW = 1.0E-37
      OFLOW = 1.0E+38
      RETURN
      END
C==========================================================
C
      REAL FUNCTION PHI(X)
C**********************************************************
C
C  1.  PHI   - FORTRAN 77 REAL FUNCTION
C  2.  IT COMPUTES THE PROBABILITY OF STANDARD NORMAL DISTRIBUTION
C      FUNCTION:
C      PHI(X) = PROB{ N < X } WHERE N ~ NORMAL( 0, 1 )
C  3.  PARAMETERS:
C        IN    X      :  SEE THE ABOVE FORMULA
C        OUT   PHI    :  PROBABILITY
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        NONE
C  5.  REFERENCES: 
C        ABRAMOWITZ AND STEGUN ( 1964, (26.2.17) OF P.932)
C
C**********************************************************
      DIMENSION B(5)
      DATA B/ 0.319381530, -0.356563782,  1.781477937,
     C         -1.821255978,  1.330274429/
      DATA PP/0.231641900/, PH/3.14159265359/
C
      IN=0
      IF(X.LT.0.0)THEN
        IN=1
        X=-X
      ENDIF
      M=5
      CALL FLOW ( UFLOW, OFLOW )
      EUFLOW = -ALOG( UFLOW )
      XXM = X*X/2.0
      IF(XXM.LT.EUFLOW)THEN
        T=1.0/(1.0+PP*X)
        ZX=(EXP(-XXM))/SQRT(2.0*PH)
        TT=1.
        BT=0.
        DO 10 I=1,M
          TT=TT*T
          BT=BT+B(I)*TT
10      CONTINUE
      ELSE
        ZX=0.
        BT=0.
      ENDIF
      PHI=1.0-ZX*BT
      IF(IN.EQ.1)THEN
        PHI=1.0-PHI
        X=-X
      ENDIF
      RETURN
      END
C==========================================================
C
       SUBROUTINE WWPR(A,B,C,PROB,IER)
C**************************************************************
C
C  1.  WWPR   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE WIENER PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { W ( T ) < C : A < T < B }
C
C  3.  PARAMETERS:
C        IN    A     :  SEE THE ABOVE FORMULA
C              B     :          " 
C              C     :          "
C        OUT   PROB  :          "
C              IER   :  ERROR AND IER > 0, IF AN ERROR OCCURS.
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - WW0B - PHI
C        - WWAB - QNG - QMACO 
C               - WFUNC1 - PHI
C
C***************************************************************  
C
C * * * * * CHECK ON THE VALIDITY OF PARAMETERS
C
      IF ( A.LT.0.0 .OR. A.GT.B ) THEN
        IER=101
        PROB=0.0
      ELSE
        IER=0
        IF ( A.EQ.B ) THEN
C
C * * * * * SET PROB = PHI( C/SQRT(B) ), IF   A = B.
C
          IF ( B.EQ.0. ) THEN
            PROB = 1.0
          ELSE
            BB = SQRT( B )
            PROB = PHI ( C / BB )
          ENDIF
        ELSE
          IF ( A.EQ.0.0 ) THEN
C
C * * * * * CALL WP0B TO COMPUTE    P { W(T) < C : 0 < T < B }
C
            CALL WP0B( B,C,PROB )
          ELSE
C
C * * * * * CALL WPAB TO COMPUTE    P { W(T) < C : A < T < B }
C 
            CALL WPAB( A,B,C,PROB )
          ENDIF
        ENDIF
        IF ( PROB.GE.100. ) THEN
          IER = PROB
          PROB = 0.
        ENDIF
      ENDIF
      RETURN
      END
C==========================================================
C    
      SUBROUTINE WWAS(A,B,C,PROB,IER)
C**********************************************************
C
C  1.  WWAS   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE WIENER PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { -C < W ( T ) < C : A < T < B }
C
C  3.  PARAMETERS:
C        IN    A     :  SEE THE ABOVE FORMULA
C              B     :          " 
C              C     :          "
C        OUT   PROB  :          "
C              IER   :  ERROR AND IER > 0, IF AN ERROR OCCURS.
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - WWAS0B - FLOW
C        - WWASAB - QNG - QMACO 
C                 - WFUNC2 - WIEN1 - PHI
C
C***************************************************************  
C
C * * * * * CHECK ON THE VALIDITY OF PARAMETERS
C
      IF ( A.LT.0.0 .OR. A.GT.B ) THEN
        IER=101
        PROB=0.0
      ELSE
        IER=0
        IF ( A.EQ.B ) THEN
C
C * * * * * SET PROB = 2*PHI( C/SQRT(B) ) - 1 , IF   A = B.
C
          IF ( B.EQ.0. ) THEN
            PROB = 1.0
          ELSE
            BB = SQRT( B )
            PROB = 2.0 * PHI( C/BB ) - 1.0
          ENDIF
        ELSE
          IF ( A.EQ.0.0 ) THEN
C
C * * * * * CALL WPAS0B TO COMPUTE    P { -C < W(T) < C : 0 < T < B }
C
            CALL WPAS0B( B,C,PROB )
          ELSE
C
C * * * * * CALL WPASAB TO COMPUTE    P { -C < W(T) < C : A < T < B }
C 
            CALL WPASAB( A,B,C,PROB )
          ENDIF
        ENDIF
        IF ( PROB.GE.100. ) THEN
          IER = PROB
          PROB = 0.
        ENDIF
      ENDIF
      RETURN
      END
C==========================================================
C
       SUBROUTINE BBPR(A,B,C,PROB,IER)
C***********************************************************
C
C  1.  BBPR   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE BROWNIAN BRIDGE PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { B ( T ) < C : A < T < B }
C
C  3.  PARAMETERS:
C        IN    A     :  SEE THE ABOVE FORMULA
C              B     :          " 
C              C     :          "
C        OUT   PROB  :          "
C              IER   :  ERROR AND IER > 0, IF AN ERROR OCCURS.
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - BB01
C        - BB0B - GWP0B - PHI 
C        - BBAB - GWPAB - QNG - QMACO 
C                       - WFUNC3 - GWP0B - PHI
C
C***************************************************************  
C
C * * * * * CHECK ON THE VALIDITY OF PARAMETERS
C
      IF ( A.LT.0.0 .OR. B.GT.1.0 .OR. A.GT.B ) THEN
        IER=102
        PROB=0.0
      ELSE
        IER=0
        IF ( A.EQ.B ) THEN
C
C * * * * * SET PROB = PHI( C/SQRT(B*(1-B)) ), IF   A = B.
C
          IF ( B.EQ.0.0.OR.B.EQ.1.0 ) THEN
            PROB = 1.0
          ELSE
            BB = SQRT( B*(1.0-B) )
            PROB = PHI( C/BB )
          ENDIF
        ELSE
          IF ( A.EQ.0.0 ) THEN
            IF ( B.EQ.1.0 ) THEN
C
C * * * * * CALL BB01 TO COMPUTE    P { B(T) < C : 0 < T < 1 }
C
              CALL BB01( C,PROB )
            ELSE
C
C * * * * * CALL BB0B TO COMPUTE    P { B(T) < C : 0 < T < B }
C
              CALL BB0B( B,C,PROB )
            ENDIF
          ELSE
            IF ( B.EQ.1.0 ) THEN
              BB = 1.0 - A
C
C * * * * * CALL BB0B TO COMPUTE    P { B(T) < C : A < T < 1 }
C
              CALL BB0B( BB,C,PROB )
            ELSE
C
C * * * * * CALL BBAB TO COMPUTE    P { B(T) < C : A < T < B }
C 
              CALL BBAB( A,B,C,PROB )
            ENDIF
          ENDIF
        ENDIF
        IF ( PROB.GE.100. ) THEN
          IER = PROB
          PROB = 0.
        ENDIF
      ENDIF
      RETURN
      END
C==========================================================
C      
      SUBROUTINE BBAS(A,B,C,PROB,IER)
C***********************************************************
C
C  1.  BBAS   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE BROWNIAN BRIDGE PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { -C < B ( T ) < C : A < T < B }
C
C  3.  PARAMETERS:
C        IN    A     :  SEE THE ABOVE FORMULA
C              B     :          " 
C              C     :          "
C        OUT   PROB  :          "
C              IER   :  ERROR AND IER > 0, IF AN ERROR OCCURS.
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - BBAS01 - FLOW
C        - BBAS0B - GWPS0B - FLOW
C                          - PHI
C        - BBASAB - GWPSAB - QNG - QMACO
C                          - WFUNC4 - WIENER - FLOW
C                                            - PHI
C
C***************************************************************  
C
C * * * * * CHECK ON THE VALIDITY OF PARAMETERS
C
      IF ( A.LT.0.0 .OR. B.GT.1.0 .OR. A.GT.B ) THEN
        IER=102
        PROB=0.0
      ELSE
        IER=0
        IF ( A.EQ.B ) THEN
C
C * * * * * SET PROB = 2*PHI ( C/SQRT(B*(1-B)) ) - 1 , IF   A = B.
C
          IF ( B.EQ.0.0.OR.B.EQ.1.0 ) THEN
            PROB = 1.0
          ELSE
            BB = SQRT( B*(1.0-B) ) 
            PROB = 2.0*PHI( C/BB ) - 1.0
          ENDIF
        ELSE
          IF ( A.EQ.0.0 ) THEN
            IF ( B.EQ.1.0 ) THEN
C
C * * * * * CALL BBAS01 TO COMPUTE    P { -C < B(T) < C : 0 < T < 1 }
C
              CALL BBAS01( C,PROB )
            ELSE
C
C * * * * * CALL BBAS0B TO COMPUTE    P { -C < B(T) < C : 0 < T < B }
C
              CALL BBAS0B( B,C,PROB )
            ENDIF
          ELSE
            IF ( B.EQ.1.0 ) THEN
              BB = 1.0 - A
C
C * * * * * CALL BBAS0B TO COMPUTE    P { -C < B(T) < C : A < T < 1 }
C
              CALL BBAS0B( BB,C,PROB )
            ELSE
C
C * * * * * CALL BBASAB TO COMPUTE    P { -C < B(T) < C : A < T < B }
C 
              CALL BBASAB( A,B,C,PROB )
            ENDIF
          ENDIF
        ENDIF
        IF ( PROB.GE.100. ) THEN
          IER = PROB
          PROB = 0.
        ENDIF
      ENDIF
      RETURN
      END      
C===========================================================
C   
      SUBROUTINE INVWW( A,B,C,D,P,IOPT,IER )
C**********************************************************
C
C  1.  INVWW   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE PARAMETER
C      SELECTED, DEPENDING UPON THE INPUT PARAMETER IOPT, OF THE WIENER
C      PROCESS.  WHEN IOPT = 1, 2 OR 3, FOR GIVEN PROBABILITY P, FOR,
C    
C      P = PROB { W ( T ) < C : A < T < B }
C
C      IT COMPUTES   C  , IF  IOPT = 1
C         "          A  ,    "     = 2
C         "          B  ,    "     = 3
C
C      WHEN IOPT = 4, 5 OR 6, FOR,
C
C      P = PROB { -C < W ( T ) < C : A < T < B }
C
C      IT COMPUTES   C  ,  IF IOPT = 4
C         "          A  ,    "     = 5
C         "          B  ,    "     = 6
C
C      WHEN IOPT = 7 OR 8, FOR,
C
C      P = PROB { W ( T ) < C+DT : A < T < B }
C
C      IT COMPUTES   C  , IF  IOPT = 7
C         "          D  ,    "     = 8
C
C      WHEN IOPT = 9 OR 10, FOR,
C
C      P = PROB { -C-DT < W ( T ) < C+DT : A < T < B }
C
C      IT COMPUTES   C  ,  IF IOPT = 9
C         "          D  ,    "     = 10
C
C  3.  PARAMETERS:
C        IN    IOPT     :  SEE THE ABOVE
C              P        :  GIVEN PROBABILITY LEVEL
C              C        :  IF IOPT =    2, 3,    5, 6,    8,    10
C              D        :          =                   7,    9
C              A        :          = 1,    3, 4,    6, 7, 8, 9, 10
C              B        :          = 1, 2,    4, 5,    7, 8, 9, 10
C        OUT   C        :  IF IOPT = 1, 4, 7, 9
C              D        :          = 8, 10
C              A        :          = 2, 5
C              B        :          = 3, 6
C              IER      :  ERROR CODE AND IER > 0, IF AN ERROR OCCURS.
C
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - WWPR - WW0B - PHI
C               - WWAB - QNG - QMACO
C                      - WFUNC1 - PHI
C        - WWAS - WWAS0B - FLOW
C               - WWASAB - QNG - QMACO
C                        - WFUNC2 - WIEN1 - PHI
C
C**********************************************************
      DATA XMAX/8.0/, TOL/0.000001/
C
C * * * * * CHECK ON THE VALIDITY OF PARAMETERS
C
      IF ( IOPT.LT.1 .OR. IOPT.GT.10 ) THEN
        IER=111
        RETURN
      ENDIF
      GOTO ( 10,20,30,40,50,60,70,75,80,85 ),IOPT
C
C * * * * * SET UP APPROPRIATE INITIAL VALUES
C
10      VMAX=XMAX
        VMIN=0.
        PROB=0.0
        CALL WWPR( A,B,VMAX,PROBX,IER )
        GO TO 90
20      VMAX = B
        VMIN=0.0
        CALL WWPR( VMIN,B,C,PROB,IER )
        CALL WWPR( B,B,C,PROBX,IER )
        GO TO 90
30      VMAX=A
        VMIN=64.
        CALL WWPR( A,VMIN,C,PROB,IER )
        CALL WWPR( A,A,C,PROBX,IER )
        GO TO 90
40      VMAX=XMAX
        VMIN=0.
        PROB=0.
        CALL WWAS( A,B,VMAX,PROBX,IER )
        GO TO 90
50      VMAX=B
        VMIN=0.
        CALL WWAS( VMIN,B,C,PROB,IER )
        CALL WWAS( B,B,C,PROBX,IER )
        GO TO 90
60      VMAX=A
        VMIN=128.
        CALL WWAS( A,VMIN,C,PROB,IER )
        CALL WWAS( A,A,C,PROBX,IER )
70      VMAX=XMAX
        VMIN=0.
        IF ( A.EQ.0.0 ) THEN
          CALL GWP0B( B,VMIN,D,PROB )
          CALL GWP0B( B,VMAX,D,PROBX )
        ELSE
          CALL GWPAB( A,B,VMIN,D,PROB )
          CALL GWPAB( A,B,VMAX,D,PROBX )
        ENDIF
        GO TO 90
75      VMAX=XMAX
        VMIN=0.
        IF ( A.EQ.0.0 ) THEN
          CALL GWP0B( B,C,VMIN,PROB )
          CALL GWP0B( B,C,VMAX,PROBX )
        ELSE
          CALL GWPAB( A,B,C,VMIN,PROB )
          CALL GWPAB( A,B,C,VMAX,PROBX )
        ENDIF
        GO TO 90
80      VMAX=XMAX
        VMIN=0.
        IF ( A.EQ.0.0 ) THEN
          CALL GWPS0B( B,VMIN,D,PROB )
          CALL GWPS0B( B,VMAX,D,PROBX )
        ELSE
          CALL GWPSAB( A,B,VMIN,D,PROB )
          CALL GWPSAB( A,B,VMAX,D,PROBX )
        ENDIF
        GO TO 90
85      VMAX=XMAX
        VMIN=0.
        IF ( A.EQ.0.0 ) THEN
          CALL GWPS0B( B,C,VMIN,PROB )
          CALL GWPS0B( B,C,VMAX,PROBX )
        ELSE
          CALL GWPSAB( A,B,C,VMIN,PROB )
          CALL GWPSAB( A,B,C,VMAX,PROBX )
        ENDIF
90    IF ( IER.NE.0 ) RETURN
C
      IF ( ABS(PROB-P).LT.TOL) THEN
         GOTO ( 310,320,330,310,320,330,310,340,310,340 ), IOPT
310         C = VMIN
            GO TO 390
320         A = VMIN
            GO TO 390
330         B = VMIN
            GO TO 390
340         D = VMIN
            GO TO 390
      ELSE
         IF (  ABS(PROBX-P).LT.TOL) THEN
            GOTO ( 360,370,380,360,370,380,360,385,360,385), IOPT
360            C = VMAX
               GO TO 390
370            A = VMAX
               GO TO 390
380            B = VMAX
               GO TO 390
385            D = VMAX
               GO TO 390
         ENDIF
      ENDIF
C
      IF ( PROB.GT.P.OR.PROBX.LT.P ) THEN
        IER=131
        RETURN
      ENDIF
C
C * * * * * ITERATIVE PROCEDURE STARTS FROM HERE 
C
      ITER = 1
100   VNEW = VMIN + (VMAX-VMIN)/2.0
      WRITE(*,992)ITER
992   FORMAT('+ THE COMPUTATIONS ARE IN PROGRESS, ITERATION NO. =',I5)
      ITER = ITER + 1
C
      GOTO ( 110,120,130,140,150,160,170,175,180,185 ), IOPT
C
110     CALL WWPR( A,B,VNEW,PROBN,IER )
        GO TO 190
120     CALL WWPR( VNEW,B,C,PROBN,IER )
        GO TO 190
130     CALL WWPR( A,VNEW,C,PROBN,IER )
        GO TO 190
140     CALL WWAS( A,B,VNEW,PROBN,IER )
        GO TO 190
150     CALL WWAS( VNEW,B,C,PROBN,IER )
        GO TO 190
160     CALL WWAS( A,VNEW,C,PROBN,IER )
        GO TO 190
170     IF ( A.EQ.0.0 ) THEN
          CALL GWP0B( B,VNEW,D,PROBN )
        ELSE
          CALL GWPAB( A,B,VNEW,D,PROBN )
        ENDIF
        GO TO 190
175     IF ( A.EQ.0.0 ) THEN
          CALL GWP0B( B,C,VNEW,PROBN )
        ELSE
          CALL GWPAB( A,B,C,VNEW,PROBN )
        ENDIF
        GO TO 190
180     IF ( A.EQ.0.0 ) THEN
          CALL GWPS0B( B,VNEW,D,PROBN )
        ELSE
          CALL GWPSAB( A,B,VNEW,D,PROBN )
        ENDIF
        GO TO 190
185     IF ( A.EQ.0.0 ) THEN
          CALL GWPS0B( B,C,VNEW,PROBN )
        ELSE
          CALL GWPSAB( A,B,C,VNEW,PROBN )
        ENDIF
190   IF ( IER.NE.0 ) RETURN
C
C * * * * * IF THE DIFFERENCE IS LESS THAN THE GIVEN TORELANCE
C                  THEN STOP THE ITERATIONS
C
      IF ( ABS(PROBN-P).GT.TOL ) THEN
        IF ( P.GT.PROBN ) THEN
          VMIN = VNEW
        ELSE
          VMAX = VNEW
        ENDIF
        GO TO 100
      ELSE
        GOTO ( 210,220,230,210,220,230,210,240,210,240 ), IOPT
210       C = VNEW
          GO TO 290
220       A = VNEW
          GO TO 290
230       B = VNEW
          GO TO 290
240       D = VNEW
290     CONTINUE
      ENDIF
390   RETURN
      END
C==========================================================
C
      SUBROUTINE INVBB( A,B,C,P,IOPT,IER )
C**********************************************************
C
C  1.  INVWW   -FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE PARAMETER
C      SELECTED, DEPENDING UPON THE INPUT PARAMETER IOPT, OF THE 
C      BROWNIAN BRIDGE PROCESS.  
C      WHEN IOPT = 1, 2 OR 3, FOR GIVEN PROBABILITY P, 
C    
C      P = PROB { B ( T ) < C : A < T < B }
C
C      IT COMPUTES   C  , IF  IOPT = 1
C         "          A  ,    "     = 2
C         "          B  ,    "     = 3
C
C      WHEN IOPT = 4, 5 OR 6, FOR,
C
C      P = PROB { -C < B ( T ) < C : A < T < B }
C
C      IT COMPUTES   C  ,  IF IOPT = 4
C         "          A  ,    "     = 5
C         "          B  ,    "     = 6
C
C  3.  PARAMETERS:
C        IN    IOPT     :  SEE THE ABOVE
C              P        :  GIVEN PROBABILITY LEVEL
C              C        :  IF IOPT =    2, 3,    5 OR 6 
C              A        :          = 1,    3, 4   OR 6
C              B        :          = 1, 2,    4 OR 5
C        OUT   C        :  IF IOPT = 1 OR 4
C              A        :          = 2 OR 5
C              B        :          = 3 OR 6
C              IER      :  ERROR CODE AND IER > 0, IF AN ERROR OCCURS.
C
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - BBPR - BB01
C               - BB0B - GWP0B - PHI
C               - BBAB - GWPAB - QNG - QMACO
C                              - WFUNC3 - GWP0B - PHI 
C        - BBAS - BBAS01 - FLOW
C               - BBAS0B - GWPS0B - FLOW
C                                 - PHI
C               - BBASAB - GWPSAB - QNG - QMACO
C                                 - WFUNC4 - WIENER - FLOW
C                                                   - PHI 
C***************************************************************
      DATA XMAX/8.0/, TOL/0.000001/
C
C * * * * * CHECK ON THE VALIDITY OF PARAMETERS
C
      IF ( IOPT.LT.1 .OR. IOPT.GT.6 ) THEN
        IER=112
        RETURN
      ENDIF
      GOTO ( 10,20,30,40,50,60 ),IOPT
C
C * * * * * SET UP APPROPRIATE INITIAL VALUES
C
10      VMAX=XMAX
        VMIN=0.
        PROB=0.
        CALL BBPR( A,B,VMAX,PROBX,IER )
        GO TO 90
20      VMAX=B
        VMIN=0.
        CALL BBPR( VMIN,B,C,PROB,IER )
        CALL BBPR( B,B,C,PROBX,IER )
        GO TO 90
30      VMAX=A
        VMIN=1.
        CALL BBPR( A,VMIN,C,PROB,IER )
        CALL BBPR( A,A,C,PROBX,IER )
        GO TO 90
40      VMAX=XMAX
        VMIN=0.
        PROB=0.
        CALL BBAS( A,B,VMAX,PROBX,IER )
        GO TO 90
50      VMAX=B
        VMIN=0.
        CALL BBAS( VMIN,B,C,PROB,IER )
        CALL BBAS( B,B,C,PROBX,IER )
        GO TO 90
60      VMAX=A
        VMIN=1.
        CALL BBAS( A,VMIN,C,PROB,IER )
        CALL BBAS( A,A,C,PROBX,IER )
90    IF ( IER.NE.0 ) RETURN
C
      IF ( ABS(PROB-P).LT.TOL) THEN
         GOTO ( 310,320,330,310,320,330), IOPT
310         C = VMIN
            GO TO 390
320         A = VMIN
            GO TO 390
330         B = VMIN
            GO TO 390
      ELSE
         IF (  ABS(PROBX-P).LT.TOL) THEN
            GOTO ( 360,370,380,360,370,380), IOPT
360            C = VMAX
               GO TO 390
370            A = VMAX
               GO TO 390
380            B = VMAX
               GO TO 390
         ENDIF
      ENDIF
C       
      IF ( PROB.GT.P.OR.PROBX.LT.P ) THEN
        IER=132
        RETURN
      ENDIF
C
C * * * * * ITERATIVE PROCEDURE STARTS FROM HERE
C
      ITER = 1
100   VNEW = VMIN + (VMAX-VMIN)/2.0
      WRITE(*,992)ITER
992   FORMAT('+ THE COMPUTATIONS ARE IN PROGRESS, ITERATION NO. =',I5)
      ITER = ITER + 1
C
      GOTO ( 110,120,130,140,150,160 ), IOPT
C
110     CALL BBPR( A,B,VNEW,PROBN,IER )
        GO TO 190
120     CALL BBPR( VNEW,B,C,PROBN,IER )
        GO TO 190
130     CALL BBPR( A,VNEW,C,PROBN,IER )
        GO TO 190
140     CALL BBAS( A,B,VNEW,PROBN,IER )
        GO TO 190
150     CALL BBAS( VNEW,B,C,PROBN,IER )
        GO TO 190
160     CALL BBAS( A,VNEW,C,PROBN,IER )
190   IF ( IER.NE.0 ) RETURN
C
C * * * * * IF THE DIFFERENCE IS LESS THAN THE GIVEN TORELANCE
C                  THEN STOP THE ITERATIONS
C
      IF ( ABS(PROBN-P).GT.TOL ) THEN
        IF ( P.GT.PROBN ) THEN
          VMIN = VNEW
        ELSE
          VMAX = VNEW
        ENDIF
        GO TO 100
      ELSE
        GOTO ( 210,220,230,210,220,230 ), IOPT
210       C = VNEW
          GO TO 290
220       A = VNEW
          GO TO 290
230       B = VNEW
290     CONTINUE
      ENDIF
390   RETURN
      END
C==========================================================
C
      SUBROUTINE WP0B( B,C,PROB )
C**********************************************************
C + + + + + SPECIAL CASE OF WPAB(A,B,C,PROB)  WHEN A = 0
C + + + + + SPECIAL CASE OF GWP0B(B,C,D,PROB) WHEN D = 0
C**********************************************************
C
C  1.  WP0B   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE WIENER PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { W ( T ) < C : 0 < T < B }
C
C  3.  PARAMETERS:
C        IN    B     :   SEE THE ABOVE FORMULA
C              C     :           "
C        OUT   PROB  :           "
C
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - PHI
C
C  5.  REFERENCES
C        - CHUNG( 1986, (3.2))
C
C********************************************************** 
      BB = SQRT( B )
      PROB = 2.0 * PHI( C/BB ) - 1.0
      RETURN
      END
C==========================================================
C
      REAL FUNCTION WFUNC1 ( U )
C**********************************************************
C
C  1.  WFUNC1     - FORTRAN 77 REAL FUNCTION
C
C  2.  THIS FUNCTION CALCULATES THE FOLLOWING FORMULA
C
C      WFUNC1=EXP(-U*U/2)*[2*PHI(CC/BB)-1]/SQRT(2*PH)
C             WHERE CC = C-SQRT(A)*U AND BB = SQRT(B-A)
C
C  3.  PARAMETERS:
C        -INFINITE < U < C/SQRT(A)
C
C  4.  SUBROUTINES AND FUNCTIONS REQUIRED:
C        - PHI
C
C**********************************************************
      COMMON /FUNCT/A,B,C,DUM(7)
      DATA PH/3.14159265359/
C
      BB = SQRT( B - A )
      CC = C - SQRT( A ) * U
      PP = 2.0 * PHI( CC/BB ) - 1.0
      CALL FLOW ( UFLOW, OFLOW )
      EUFLOW = -ALOG( UFLOW )
      UUM = U*U/2.0
      IF ( UUM.GT.EUFLOW ) THEN
         UUM = EUFLOW
      ENDIF
      WFUNC1 = PP * EXP( -UUM ) / SQRT(2.0*PH )
      RETURN
      END
C==========================================================
C
      SUBROUTINE WPAB ( A,B,C,PROB )
C**********************************************************
C + + + + + SPECIAL CASE OF GWPAB(A,B,C,D,PROB) WHEN D = 0
C***********************************************************
C
C  1.  WPAB   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE WIENER PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { W ( T ) < C : A < T < B }
C
C  3.  PARAMETERS:
C        IN    A     :   SEE THE ABOVE FORMULA
C              B     :           "
C              C     :           "
C        OUT   PROB  :           "
C
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - WFUNC1 - PHI
C        - QNG - QMACO
C
C  5.  REFERENCES
C        - CHUNG ( 1986, (3.9))
C        - CSORGO ( 1976, (3.4) OF P. 554)
C        - QUADPACK ( 1983, SUBROUTINE QNG( P.130-136))
C        - RENYI ( 1953, (3.6) OF P. 208)
C
C********************************************************** 
      COMMON /FUNCT/A1,B1,C1,DUM(7)
      EXTERNAL WFUNC1
      DATA EPSABS/0.000005/, EPSREL/0.000005/, XMIN/-8.0/
C
      A1 = A
      B1 = B
      C1 = C
      XMAX = C/SQRT(A)
C
C * * * * * CALL QNG FOR NUMERICAL INTEGRATIONS WITH FUNCTION WFUNC1
C
      CALL QNG(WFUNC1,XMIN,XMAX,EPSABS,EPSREL,RESULT,ABSE,NEVAL,IER)
      IF ( IER.NE.0 ) THEN
        PROB = 121.
      ELSE
        PROB = RESULT
      ENDIF
      RETURN
      END
C==========================================================
C
      SUBROUTINE WPAS0B ( B,C,PROB )
C**********************************************************
C + + + + + SPECIAL CASE OF WPASAB(A,B,C,PROB)  WHEN A = 0
C + + + + + SPECIAL CASE OF WIEN1(C2,C1,B,PROB) WHEN C1 = C2 = C
C**********************************************************
C
C  1.  WPAS0B   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE WIENER PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { -C < W ( T ) < C : 0 < T < B }
C
C  3.  PARAMETERS:
C        IN    B     :   SEE THE ABOVE FORMULA
C              C     :           "
C        OUT   PROB  :           "
C
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - FLOW
C
C  5.  REFERENCES
C        - CHUNG( 1986, (4.4))
C        - FELLER( 1966, (5.11) OF P. 330)
C
C********************************************************** 
      DATA IMAX/100/, PH/3.14159265359/
C
      CALL FLOW( UFLOW,OFLOW )
      EUFLOW = -ALOG( UFLOW )
      CC = PH * PH * B / ( 8.0 * C * C )
      SIGN = 1.0
      SUM = EXP( -CC )
      DO 10 K = 1, IMAX
        KK = 2 * K + 1
        XK = FLOAT( KK )
        ARG = XK * XK * CC
        IF ( ARG .GT. EUFLOW ) THEN
          GO TO 20
        ELSE
          SIGN = -1.0 * SIGN
          SUM = SUM + SIGN * EXP( -ARG ) / XK
        ENDIF
10    CONTINUE
20    PROB = SUM * 4.0 / PH
      RETURN
      END
C==========================================================
C
      REAL FUNCTION WFUNC2 ( U )  
C**********************************************************
C
C  1.  WFUNC2     - FORTRAN 77 REAL FUNCTION
C
C  2.  THIS FUNCTION CALCULATES THE FOLLOWING FORMULA
C
C      WFUNC2=EXP(-U*U/2)*PROB{-C-U*AA<W(T)<C-U*AA:0<T<B-A}/SQRT(2*PH)
C        WHERE  AA = SQRT(A)     
C
C  3.  PARAMETERS:
C        0 < U < C/SQRT(A)
C
C  4.  SUBROUTINES AND FUNCTIONS REQUIRED:
C        - WFUNC2 - WIEN1 - PHI
C        - QNG - QMACO
C
C**********************************************************
      COMMON /FUNCT/ A,B,C,DUM(7)
      DATA PH/3.14159265359/
C
      UU = SQRT(A) * U
      BB = B - A
C
C * * * * * CALL WIEN1 TO COMPUTE PROB = PROB{-C-UU<W(T)<C-UU : 0<T<B-A}
C
      CALL WIEN1 ( -C-UU, C-UU, BB, PROB )
      CALL FLOW ( UFLOW, OFLOW )
      EUFLOW = -ALOG( UFLOW )
      UUM = U*U/2.0
      IF ( UUM.GT.EUFLOW ) THEN
         UUM = EUFLOW
      ENDIF
      WFUNC2 = EXP ( -UUM ) * PROB / SQRT ( 2.*PH )
      RETURN
      END
C==========================================================
C
      SUBROUTINE WPASAB ( A,B,C,PROB )
C**********************************************************
C + + + + + SPECIAL CASE OF GWPSAB(A,B,C,D,PROB) WHEN D = 0
C**********************************************************
C
C  1.  WPASAB   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE WIENER PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { -C < W ( T ) < C : A < T < B }
C
C  3.  PARAMETERS:
C        IN    A     :   SEE THE ABOVE FORMULA
C              B     :           "
C              C     :           "
C        OUT   PROB  :           "
C
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - WFUNC2 - WIEN1 - PHI
C        - QNG - QMACO
C
C  5.  REFERENCES
C        - CHUNG( 1986, (4.11))
C        - QUADPACK( 1983, SUBROUTINE QNG( P.130-136))
C
C********************************************************** 
      COMMON /FUNCT/ A1,B1,C1,DUM(7)
      EXTERNAL WFUNC2
      DATA EPSABS/0.000005/, EPSREL/0.000005/, XMIN/0.0/
C
      A1 = A
      B1 = B
      C1 = C
      P = C / SQRT( A )
C
C * * * * * CALL QNG FOR NUMERICAL INTEGRATIONS WITH FUNCTION WFUNC1
C
      CALL QNG(WFUNC2,XMIN,P,EPSABS,EPSREL,RESULT,ABSE,NEVAL,IER)
      IF ( IER.NE.0 ) THEN
        PROB = 122.0
      ELSE
        PROB = RESULT * 2.0
      ENDIF
      RETURN
      END
C==========================================================
C
      SUBROUTINE WIEN1 ( C2,C1,B,PROB )
C**********************************************************
C + + + + + SPECIAL CASE OF WIENER(C2,D2,C1,D1,B,PROB) WHEN D2=D1=0
C**********************************************************
C
C  1.  WIEN1   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE WIENER PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { C2 < W ( T ) < C1 : 0 < T < B }
C
C      IT IS A SPECIAL CASE OF THE ROUTINE WIENER WHEN D2 = D1 = 0   
C
C  3.  PARAMETERS:
C        IN    B     :   SEE THE ABOVE FORMULA
C              C2    :           "              AND C2 < 0
C              C1    :           "                  C1 > 0
C        OUT   PROB  :           "
C
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - PHI
C
C  5.  REFERENCES
C        - CHUNG( 1986, (4.2) AND (4.3))
C        - CSORGO( 1967, (2.5) OF P. 553)
C        - FELLER( 1966, (5.8) OF P. 329 AND (5.9) OF P. 330)
C
C********************************************************** 
      DATA IMAX/100/, TOL/1.0E-9/
C
      BB = SQRT( B )
      CB1 = C1 / BB
      CB2 = C2 / BB
      CC = CB1 - CB2
      SIGN = 1.0
      SUM = 1.0
      DO 10 K = 1, IMAX
        CBK = -FLOAT( K ) * CC
        ADD = PHI( CBK + CB1 ) + PHI( CBK - CB2 )
        IF ( ABS(ADD).LT.TOL ) GO TO 20
        SIGN = -1.0 * SIGN
        SUM = SUM + 2.0 * ADD * SIGN
10    CONTINUE
20    PROB = SUM
      RETURN
      END
C===========================================================
C
      SUBROUTINE BB01( C,PROB )
C***********************************************************
C + + + + + SPECIAL CASE OF BB0B(B,C,PROB) WHEN B = 1
C***********************************************************
C
C  1.  BB01   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE BROWNIAN BRIDGE PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { B ( T ) < C : 0 < T < 1 }
C
C  3.  PARAMETERS:
C        IN    C     :  SEE THE ABOVE FORMULA
C        OUT   PROB  :          "
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        NONE
C
C***************************************************************  
      PROB = 1.0 - EXP ( -2.0*C*C )
      RETURN
      END
C==========================================================
C
      SUBROUTINE BB0B ( B,C,PROB )
C***********************************************************
C + + + + + SPECIAL CASE OF BBAB(A,B,C,PROB)   WHEN A = 0
C + + + + + SPECIAL CASE OF GWP0B(BB,C,D,PROB) WHEN D=C, BB=B/(1-B)
C***********************************************************
C
C  1.  BBAS   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE BROWNIAN BRIDGE PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { B ( T ) < C : 0 < T < B }
C
C  3.  PARAMETERS:
C        IN    B     :  SEE THE ABOVE FORMULA
C              C     :          "
C        OUT   PROB  :          "
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - GWP0B - PHI                                 
C
C  5.  REFERENCES:
C        - CHUNG ( 1986, (3.3))
C        - HALL AND WELLNER( 1980, (2.8) OF P. 136)
C        - KOZIOL AND BYAR( 1975, (2.3) OF P.508)
C
C***************************************************************  
      BB = B / ( 1. - B )
      CALL GWP0B ( BB,C,C,PROB )
      RETURN
      END
C==========================================================
C
      SUBROUTINE BBAB ( A,B,C,PROB )
C***********************************************************
C + + + + + SPECIAL CASE OF GWPAB(AA,BB,C,D,PROB) WHEN
C              AA = A/(1-A) , BB = B/(1-B) AND C = D
C***********************************************************
C
C  1.  BBAB   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE BROWNIAN BRIDGE PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { B ( T ) < C : A < T < B }
C
C  3.  PARAMETERS:
C        IN    A     :  SEE THE ABOVE FORMULA
C              B     :          " 
C              C     :          "
C        OUT   PROB  :          "
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - GWPAB - QNG - QMACO
C                - WFUNC3 - GWP0B - PHI
C
C  5.  REFERENCES:
C        - CHUNG ( 1986, (3.10))
C        - CSAKI ( 1981, (2.17) OF P. 259)
C        - CSORGO ( 1983, (4.2.10) OF P.37)
C
C***************************************************************  
      AA = A / ( 1. - A )
      BB = B / ( 1. - B )
      CALL GWPAB( AA,BB,C,C,PROB )
      RETURN
      END
C==========================================================
C
      SUBROUTINE BBAS01( C,PROB )
C***********************************************************
C + + + + + SPECIAL CASE OF BBAS0B(B,C,PROB) WHEN B = 1
C***********************************************************
C
C  1.  BBAS01   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE BROWNIAN BRIDGE PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { -C < B ( T ) < C : 0 < T < 1 }
C
C  3.  PARAMETERS:
C        IN    C     :  SEE THE ABOVE FORMULA
C        OUT   PROB  :          "
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - FLOW
C
C***************************************************************  
      DATA IMAX/100/
      CALL FLOW( UFLOW,OFLOW )
      EUFLOW = -ALOG( UFLOW )
      CC = 2. * C * C
      SIGN = 1.0
      SUM = 0.
      DO 10 K = 1, IMAX
        UP = CC * K * K
        IF ( UP.GE.EUFLOW ) THEN
          GO TO 20
        ELSE
          SIGN = SIGN * (-1)
          SUM = SUM + SIGN * EXP ( -UP )
        ENDIF
10    CONTINUE
20    PROB = 1.0 + 2.0 * SUM
      RETURN
      END
C==========================================================
C
      SUBROUTINE BBAS0B ( B,C,PROB )
C***********************************************************
C + + + + + SPECIAL CASE OF BBASAB(A,B,C,PROB)  WHEN A = 0
C + + + + + SPECIAL CASE OF GWPS0B(BB,C,D,PROB) WHEN C=D, BB=B/(1-B)
C***********************************************************
C
C  1.  BBAS0B   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE BROWNIAN BRIDGE PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { -C < B ( T ) < C : 0 < T < B }
C
C  3.  PARAMETERS:
C        IN    B     :  SEE THE ABOVE FORMULA
C              C     :          "
C        OUT   PROB  :          "
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - GWPS0B - FLOW
C                 - PHI
C
C  5.  REFERNCES:
C        - CHUNG ( 1986, (4.5))
C        - HALL AND WELLNER ( 1980, (2.9) OF P. 136)
C
C***************************************************************  
      BB = B / ( 1. - B )
      CALL GWPS0B(BB,C,C,PROB)
      RETURN
      END
C==========================================================
C
      SUBROUTINE BBASAB( A,B,C,PROB )
C***********************************************************
C + + + + + SPECIAL CASE OF GWPSAB(AA,BB,C,D,PROB) WHEN 
C             AA=A/(1-A), BB=B/(1-B) AND C=D
C***********************************************************
C
C  1.  BBASAB   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE BROWNIAN BRIDGE PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { -C < B ( T ) < C : A < T < B }
C
C  3.  PARAMETERS:
C        IN    A     :  SEE THE ABOVE FORMULA
C              B     :          " 
C              C     :          "
C        OUT   PROB  :          "
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - GWPSAB - QNG - QMACO
C                 - WFUNC4 - WIENER - FLOW
C                                   - PHI
C
C  5.  REFERNCES:
C        - CHUNG ( 1986, (4.12))
C
C***************************************************************  
      AA = A / ( 1. - A )
      BB = B / ( 1. - B )
      CALL GWPSAB( AA,BB,C,C,PROB )
      RETURN
      END
C==========================================================
C
      SUBROUTINE GWP0B ( B,C,D,PROB )
C***********************************************************
C + + + + + SPECIAL CASE OF GWPAB(A,B,C,D,PROB) WHEN A = 0
C***********************************************************
C
C  1.  GWP0B   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE WIENER PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { W ( T ) < C + D*T : 0 < T < B }
C
C  3.  PARAMETERS:
C        IN    B     :  SEE THE ABOVE FORMULA
C              C     :          "
C              D     :          "
C        OUT   PROB  :          "
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - PHI
C
C  5.  REFERENCES:
C        - CHUNG ( 1986, (3.1))
C
C***************************************************************  
      BB = SQRT(B)
      C1 = ( C + D*B )/BB
      C2 = (-C + D*B )/BB
      PROB = PHI( C1 ) - EXP( -2.0*C*D ) * PHI( C2 )
      RETURN
      END
C==========================================================
C
      REAL FUNCTION WFUNC3 ( U )
C***********************************************************
C
C  1.  WFUNC3   - FORTRAN 77 REAL FUNCTION
C
C  2.  IT CALCULATES THE FOLLOWING FORMULA
C
C      WFUNC3=EXP(-U*U/2)*PROB{W(T)<Q-U*AA+D*T:0<T<B-A}/SQRT(2*PH)
C             WHERE Q=C+D*A AND AA=SQRT(A)
C
C  3.  PARAMETERS:
C        -INFINITE < U < C + D*A
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - GWP0B - PHI
C
C  5.  REFERENCES:
C        - CHUNG (1986, (3.8))
C
C***************************************************************  
      COMMON /FUNCT/A,B,C,D,DUM(6)
      DATA PH/3.14159265359/
      BB = B - A
      CC = C + D*A - SQRT(A)*U
      CALL GWP0B( BB,CC,D,PROB )
      CALL FLOW ( UFLOW, OFLOW )
      EUFLOW = -ALOG( UFLOW )
      UUM = U*U/2.0
      IF ( UUM.GT.EUFLOW ) THEN
         UUM = EUFLOW
      ENDIF
      WFUNC3 = EXP( -UUM ) * PROB / SQRT(2.*PH)
      RETURN
      END
C==========================================================
C
      SUBROUTINE GWPAB ( A,B,C,D,PROB )
C***********************************************************
C
C  1.  GWPAB   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE WIENER PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { W ( T ) < C + D*T : A < T < B }
C
C  3.  PARAMETERS:
C        IN    A     :  SEE THE ABOVE FORMULA
C              B     :          " 
C              C     :          "
C              D     :          "
C        OUT   PROB  :          "
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - QNG - QMACO
C        - WFUNC3 - GWP0B - PHI
C
C  5.  REFERNCES:
C        - CHUNG ( 1986, (3.5))
C
C***************************************************************  
      COMMON /FUNCT/A1,B1,C1,D1,DUM(6)
      EXTERNAL WFUNC3
      DATA EPSABS/0.000005/, EPSREL/0.000005/, XMIN/-8.0/
C
      A1 = A
      B1 = B
      C1 = C
      D1 = D
      XMAX = ( C + D*A ) / SQRT(A)
C
C * * * * * CALL QNG FOR NUMERICAL INTEGRATION WITH WFUNC3
C
      CALL QNG( WFUNC3,XMIN,XMAX,EPSABS,EPSREL,RESULT,ABSE,NEVAL,IER )
      IF ( IER.NE.0 ) THEN
        PROB = 123.
      ELSE
        PROB = RESULT
      ENDIF
      RETURN
      END
C==========================================================
C
      SUBROUTINE GWPS0B ( B,C,D,PROB )
C***********************************************************
C + + + + + SPECIAL CASE OF GWPSAB(A,B,C,D,PROB) WHEN A = 0
C***********************************************************
C
C  1.  GWPS0B  - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE WIENER PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { -C - D*T < W ( T ) < C + D*T : 0 < T < B }
C
C  3.  PARAMETERS:
C        IN    B     :  SEE THE ABOVE FORMULA
C              C     :          "
C              D     :          "
C        OUT   PROB  :          "
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - FLOW
C        - PHI
C
C  5.  REFERENCES:
C        - CHUNG ( 1986, (4.1))
C        - GILLASPIE AND FISHER ( 1979, P. 921)
C
C***************************************************************  
      DATA IMAX/100/
C
      CALL FLOW( UFLOW,OFLOW )
      EUFLOW = -ALOG( UFLOW )
      BB = SQRT( B )
      BC = ( C + D*B ) / BB
      CD = 2.0 * C * D
      SIGN = 1.0
      SUM = 0.
      DO 10 K = 1, IMAX
        XK = FLOAT( K )
        UP = CD * XK * XK
        IF ( UP.GE.EUFLOW ) THEN
          GO TO 20
        ELSE
          AD = -2.0 * XK * C / BB
          SIGN = SIGN * (-1.0)
          TERM = PHI( AD + BC ) - PHI( AD - BC )
          SUM = SUM + SIGN * EXP(-UP) * TERM
        ENDIF
10    CONTINUE
20    PROB = 1.0 - 2.0 * PHI(-BC) + 2.0 * SUM
      RETURN
      END
C==========================================================
C
      REAL FUNCTION WFUNC4( U )
C***********************************************************
C
C  1.  WFUNC4   - FORTRAN 77 REAL FUNCTION
C
C  2.  IT CALCULATES THE FOLLOWING FORMULA
C
C      WFUNC4=EXP(-U*U/2)*
C              PROB{-Q-U*AA-D*T<W(T)<Q-U*AA+D*T:0<T<B-A}/SQRT(2*PH)
C        WHERE Q=C+D*A AND AA=SQRT(A)
C
C  3.  PARAMETERS:
C        -C -D*A < U < C + D*A
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - WIENER - FLOW
C                 - PHI
C
C  5.  REFERENCES:
C
C        - CHUNG (1986, (4.7))
C
C***************************************************************  
      COMMON /FUNCT/A,B,C,D,DUM(6)
      DATA PH/3.14159265359/
C
      CD = C + D*A
      UU = SQRT( A ) * U
      CALL WIENER ( -CD-UU, -D, CD-UU, D, B-A, PROB )
      CALL FLOW ( UFLOW, OFLOW )
      EUFLOW = -ALOG( UFLOW )
      UUM = U*U/2.0
      IF ( UUM.GT.EUFLOW ) THEN
         UUM = EUFLOW
      ENDIF
      WFUNC4 = EXP( -UUM ) * PROB / SQRT(2.0*PH)
      RETURN
      END
C==========================================================
C
      SUBROUTINE GWPSAB ( A,B,C,D,PROB )
C***********************************************************
C
C  1.  GWPSAB  - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE WIENER PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { -C - D*T < W ( T ) < C + D*T : A < T < B }
C
C  3.  PARAMETERS:
C        IN    A     :  SEE THE ABOVE FORMULA
C              B     :          " 
C              C     :          "
C              D     :          "
C        OUT   PROB  :          "
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - QNG - QMACO
C        - WFUNC4 - WIENER - FLOW
C                          - PHI
C
C  5.  REFERENCES:
C        - CHUNG ( 1986, (4.7))
C
C***************************************************************  
      COMMON /FUNCT/A1,B1,C1,D1,DUM(6)
      EXTERNAL WFUNC4
      DATA EPSABS/0.000005/, EPSREL/0.000005/, XMIN/0.0/ 
C
      A1 = A
      B1 = B
      C1 = C
      D1 = D
      CD = ( C + D*A ) / SQRT(A)
C
C * * * * * CALL QNG FOR NUMERICAL INTEGRATION WITH WFUNC4
C
      CALL QNG( WFUNC4,XMIN,CD,EPSABS,EPSREL,RESULT,ABSE,NEVAL,IER )
      IF ( IER.NE.0 ) THEN
        PROB = 124.
      ELSE
        PROB = RESULT * 2.0
      ENDIF
      RETURN
      END
C==========================================================
C
      SUBROUTINE WIENER ( C2,D2,C1,D1,S,PROB )
C***********************************************************
C
C  1.  WIENER   - FORTRAN 77 SUBROUTINE
C
C  2.  THE ROUTINE CALCULATES AN APPROXIMATION RESULT OF THE 
C      PROBABILITY OF THE WIENER PROCESS OF THE FOLLOWING FORM:
C
C      PROB = P { C2 + D2*T < W ( T ) < C1 + D1*T : 0 < T < S }
C
C  3.  PARAMETERS:
C        IN    C2    :  SEE THE ABOVE FORMULA
C              D2    :          "
C              C1    :          "
C              D1    :          "
C              S     :          "
C        OUT   PROB  :          "
C  
C  4.  SUBROUTINES OR FUNCTIONS REQUIRED:
C        - FLOW
C        - PHI
C
C  5.  REFERENCES:
C
C        - ANDERSON (1961, (4.32) OF P.180)
C        - CHUNG (1986, (2.9))
C
C***************************************************************  
      DATA IMAX/100/
C
C * * * * * SETTING UP ALL CONSTANT TERMS FOR COMPUTATIONS
C
      SS   = SQRT ( S )
      V    = ( C1 + D1*S ) / SS
      W    = ( C2 + D2*S ) / SS
      CC   = C1 - C2
      DD   = D1 - D2
      CD1  = CC * D1 + DD * C1
      CD2  = CC * D2 + DD * C2
      C1D1 = C1 * D1
      C2D2 = C2 * D2
      CDCD = C1 * D2 - D1 * C2
      CD   = CC * DD
      CCSS = -2.0 * CC / SS
      C1S  = 2.0 * C1 / SS
      C2S  = 2.0 * C2 / SS
C
C * * * * * CALL FLOW TO OBTAIN MINIMUM AND MAXIMUM ALLOWED NO.
C
      CALL FLOW ( UFLOW, OFLOW )
      EUFLOW = -ALOG( UFLOW )
      SUM = 0.0
      DO 50 K = 1, IMAX
        X = FLOAT( K )
        ISTOP = 0
        CSK = CCSS * X
        CDK = CD * X * X
        P1 = CSK + W
        Q1 = CSK + V
        P2 = CSK - W
        Q2 = CSK - V
C
        S1 = 2.0 * ( CDK + X * CDCD )
        IF ( S1 .GT. EUFLOW ) THEN
          ISTOP = ISTOP + 1
          GO TO 10
        ELSE
          SUM = SUM + EXP( -S1 ) * ( PHI( Q1 ) - PHI( P1 ) )
        ENDIF
C
10      S2 = 2.0 * ( CDK - X * CDCD )
        IF ( S2 .GT. EUFLOW ) THEN
          ISTOP = ISTOP + 1
          GO TO 20
        ELSE
          SUM = SUM + EXP( -S2 ) * ( PHI( P2 ) - PHI( Q2 ) )
        ENDIF
C
20      S3 = 2.0 * ( CDK + X * CD2 + C2D2 )
        IF ( S3 .GT. EUFLOW ) THEN
          ISTOP = ISTOP + 1
          GO TO 30
        ELSE
          P3 = P1 - C2S
          Q3 = Q1 - C2S
          SUM = SUM - EXP( -S3 ) * ( PHI( Q3 ) - PHI( P3 ) )
        ENDIF
C
30      S4 = 2.0 * ( CDK - X * CD1 + C1D1 )
        IF( S4 .GT. EUFLOW ) THEN
          ISTOP = ISTOP + 1
          GO TO 40
        ELSE
          P4 = P2 + C1S
          Q4 = Q2 + C1S
          SUM = SUM - EXP( -S4 ) * ( PHI( P4 ) - PHI( Q4 ) ) 
        ENDIF
C
40      IF ( ISTOP.EQ.4 ) GO TO 60
50    CONTINUE
C
60    PROB = 1.0 - PHI( -V ) - PHI( W ) + SUM
      RETURN
      END
C==========================================================
C
      SUBROUTINE QNG(F,A,B,EPSABS,EPSREL,RESULT,ABSERR,NEVAL,IER)
C.......................................................................
C
C 1.     QNG
C        NON-ADAPTIVE INTEGRATION
C           STANDARD FORTRAN SUBROUTINE
C
C 2.     PURPOSE
C           THE ROUTINE CALCULATES AN APPROXIMATION  RESULT  TO
C           A GIVEN DEFINITE INTEGRAL  I = INTEGRAL OF  F  OVER (A,B),
C           HOPEFULLY SATISFYING FOLLOWING CLAIM FOR ACCURACY
C           ABS(I-RESULT).LE.MAX(EPSABS,EPSREL*ABS(I)).
C
C
C 3.     CALLING SEQUENCE
C           CALL QNG(F,A,B,EPSABS,EPSREL,RESULT,ABSERR,NEVAL,IER)
C
C        PARAMETERS
C         ON ENTRY
C           F      - REAL
C                             IF  EPSABS.LT.0 AND EPSREL.LT.0,
C                    THE ROUTINE WILL END WITH IER = 6.
C
C         ON RETURN
C          RESULT - REAL
C                    APPROXIMATION TO THE INTEGRAL I
C                    RESULT IS OBTAINED BY APPLYING THE 21-POINT
C                    GAUSS-KRONROD RULE (RES21) OBTAINED BY OPTIMAL
C                    ADDITION OF ABSCISSAE TO THE 10-POINT GAUSS RULE
C                    (RES10), OR BY APPLYING THE 43-POINT RULE (RES43)
C                                      IF  EPSABS.LT.0 AND EPSREL.LT.0,
C                    THE ROUTINE WILL END WITH IER = 6.
C
C         ON RETURN
C          RESULT - REAL
C                    APPROXIMATION TO THE INTEGRAL I
C                    RESULT IS OBTAINED BY APPLYING THE 21-POINT
C                    GAUSS-KRONROD RULE (RES21) OBTAINED BY OPTIMAL
C                    ADDITION OF ABSCISSAE TO THE 10-POINT GAUSS RULE
C                    (RES10), OR BY APPLYING THE 43-POINT RULE (RES43)
C                    OBTAINED BY OPTIMAL ADDITION OF ABSCISSAE TO THE
C                    21-POINT GAUSS-KRONROD RULE, OR BY APPLYING THE
C                    87-POINT RULE (RES87) OBTAINED BY OPTIMAL ADDITION
C                    OF ABSCISSAE TO THE 43-POINT RULE.
C
C           ABSERR - REAL
C                    ESTIMATE OF THE MODULUS OF THE ABSOLUTE ERROR,
C                    WHICH SHOULD EQUAL OR EXCEED ABS(I-RESULT)
C
C           NEVAL  - INTEGER
C                    NUMBER OF INTEGRAND EVALUATIONS
C
C           IER    - IER = 0 NORMAL AND RELIABLE TERMINATION OF THE
C                            ROUTINE. IT IS ASSUMED THAT THE REQUESTED
C                            ACCURACY HAS BEEN ACHIEVED.
C                    IER.GT.0 ABNORMAL TERMINATION OF THE ROUTINE. IT IS
C                            ASSUMED THAT THE REQUESTED ACCURACY HAS
C                            NOT BEEN ACHIEVED.
C                    IER = 1 THE MAXIMUM NUMBER OF STEPS HAS BEEN
C                            EXECUTED. THE INTEGRAL IS PROBABLY TOO
C                            DIFFICULT TO BE CALCULATED BY QNG.
C                        = 6 THE INPUT IS INVALID, BECAUSE
C                            EPSABS.LT.0 AND EPSREL.LT.0,
C                            RESULT, ABSERR AND NEVAL ARE SET TO ZERO.
C
C
C 4.     SUBROUTINES OR FUNCTIONS NEEDED
C               - F (USER-PROVIDED FUNCTION)
C               - QMACO
C               - FORTRAN ABS, AMAX1, AMIN1
C
C.......................................................................
C
      REAL A,ABSC,ABSERR,B,CENTR,DHLGTH,EPMACH,EPSABS,EPSREL,F,FCENTR,
     *  FVAL,FVAL1,FVAL2,FV1,FV2,FV3,FV4,HLGTH,OFLOW,RESULT,RES10,RES21,
     *  RES43,RES87,RESABS,RESASC,RESKH,SAVFUN,UFLOW,W10,W21A,W21B,W43A,
     *  W43B,W87A,W87B,X1,X2,X3,X4
      INTEGER IER,IPX,K,L,NEVAL
C
      DIMENSION FV1(5),FV2(5),FV3(5),FV4(5),X1(5),X2(5),X3(11),X4(22),
     *  W10(5),W21A(5),W21B(6),W43A(10),W43B(12),W87A(21),W87B(23),
     *  SAVFUN(21)
C
C           THE FOLLOWING DATA STATEMENTS CONTAIN THE ABSCISSAE
C           AND WEIGHTS OF THE INTEGRATION RULES USED.
C
C           X1      ABSCISSAE COMMON TO THE 10-, 21-, 43- AND 87-POINT
C                   RULE
C           X2      ABSCISSAE COMMON TO THE 21-, 43- AND 87-POINT RULE
C           X3      ABSCISSAE COMMON TO THE 43- AND 87-POINT RULE
C           X4      ABSCISSAE OF THE 87-POINT RULE
C           W10     WEIGHTS OF THE 10-POINT FORMULA
C           W21A    WEIGHTS OF THE 21-POINT FORMULA FOR ABSCISSAE X1
C           W21B    WEIGHTS OF THE 21-POINT FORMULA FOR ABSCISSAE X2
C           W43A    WEIGHTS OF THE 43-POINT FORMULA FOR ABSISSAE X1, X3
C           W43B    WEIGHTS OF THE 43-POINT FORMULA FOR ABSCISSAE X3
C           W87A    WEIGHTS OF THE 87-POINT FORMULA FOR ABSCISSAE X1,
C                   X2 AND X3
C           W87B    WEIGHTS OF THE 87-POINT FORMULA FOR ABSCISSAE X4
C
      DATA X1(1),X1(2),X1(3),X1(4),X1(5)/
     *     9.739065285171717E-01,     8.650633666889845E-01,
     *     6.794095682990244E-01,     4.333953941292472E-01,
     *     1.488743389816312E-01/
      DATA X2(1),X2(2),X2(3),X2(4),X2(5)/
     *     9.956571630258081E-01,     9.301574913557082E-01,
     *     7.808177265864169E-01,     5.627571346686047E-01,
     *     2.943928627014602E-01/
      DATA X3(1),X3(2),X3(3),X3(4),X3(5),X3(6),X3(7),X3(8),X3(9),X3(10),
     *  X3(11)/
     *     9.993333609019321E-01,     9.874334029080889E-01,
     *     9.548079348142663E-01,     9.001486957483283E-01,
     *     8.251983149831142E-01,     7.321483889893050E-01,
     *     6.228479705377252E-01,     4.994795740710565E-01,
     *     3.649016613465808E-01,     2.222549197766013E-01,
     *     7.465061746138332E-02/
      DATA X4(1),X4(2),X4(3),X4(4),X4(5),X4(6),X4(7),X4(8),X4(9),X4(10),
     *  X4(11),X4(12),X4(13),X4(14),X4(15),X4(16),X4(17),X4(18),X4(19),
     *  X4(20),X4(21),X4(22)/         9.999029772627292E-01,
     *     9.979898959866787E-01,     9.921754978606872E-01,
     *     9.813581635727128E-01,     9.650576238583846E-01,
     *     9.431676131336706E-01,     9.158064146855072E-01,
     *     8.832216577713165E-01,     8.457107484624157E-01,
     *     8.035576580352310E-01,     7.570057306854956E-01,
     *     7.062732097873218E-01,     6.515894665011779E-01,
     *     5.932233740579611E-01,     5.314936059708319E-01,
     *     4.667636230420228E-01,     3.994248478592188E-01,
     *     3.298748771061883E-01,     2.585035592021616E-01,
     *     1.856953965683467E-01,     1.118422131799075E-01,
     *     3.735212339461987E-02/
      DATA W10(1),W10(2),W10(3),W10(4),W10(5)/
     *     6.667134430868814E-02,     1.494513491505806E-01,
     *     2.190863625159820E-01,     2.692667193099964E-01,
     *     2.955242247147529E-01/
      DATA W21A(1),W21A(2),W21A(3),W21A(4),W21A(5)/
     *     3.255816230796473E-02,     7.503967481091995E-02,
     *     1.093871588022976E-01,     1.347092173114733E-01,
     *     1.477391049013385E-01/
      DATA W21B(1),W21B(2),W21B(3),W21B(4),W21B(5),W21B(6)/
     *     1.169463886737187E-02,     5.475589657435200E-02,
     *     9.312545458369761E-02,     1.234919762620659E-01,
     *     1.427759385770601E-01,     1.494455540029169E-01/
      DATA W43A(1),W43A(2),W43A(3),W43A(4),W43A(5),W43A(6),W43A(7),
     *  W43A(8),W43A(9),W43A(10)/     1.629673428966656E-02,
     *     3.752287612086950E-02,     5.469490205825544E-02,
     *     6.735541460947809E-02,     7.387019963239395E-02,
     *     5.768556059769796E-03,     2.737189059324884E-02,
     *     4.656082691042883E-02,     6.174499520144256E-02,
     *     7.138726726869340E-02/
      DATA W43B(1),W43B(2),W43B(3),W43B(4),W43B(5),W43B(6),W43B(7),
     *  W43B(8),W43B(9),W43B(10),W43B(11),W43B(12)/
     *     1.844477640212414E-03,     1.079868958589165E-02,
     *     2.189536386779543E-02,     3.259746397534569E-02,
     *     4.216313793519181E-02,     5.074193960018458E-02,
     *     5.837939554261925E-02,     6.474640495144589E-02,
     *     6.956619791235648E-02,     7.282444147183321E-02,
     *     7.450775101417512E-02,     7.472214751740301E-02/
      DATA W87A(1),W87A(2),W87A(3),W87A(4),W87A(5),W87A(6),W87A(7),
     *  W87A(8),W87A(9),W87A(10),W87A(11),W87A(12),W87A(13),W87A(14),
     * W87A(15),W87A(16),W87A(17),W87A(18),W87A(19),W87A(20),W87A(21)/
     *     8.148377384149173E-03,     1.876143820156282E-02,
     *     2.734745105005229E-02,     3.367770731163793E-02,
     *     3.693509982042791E-02,     2.884872430211531E-03,
     *     1.368594602271270E-02,     2.328041350288831E-02,
     *     3.087249761171336E-02,     3.569363363941877E-02,
     *     9.152833452022414E-04,     5.399280219300471E-03,
     *     1.094767960111893E-02,     1.629873169678734E-02,
     *     2.108156888920384E-02,     2.537096976925383E-02,
     *     2.918969775647575E-02,     3.237320246720279E-02,
     *     3.478309895036514E-02,     3.641222073135179E-02,
     *     3.725387550304771E-02/
      DATA W87B(1),W87B(2),W87B(3),W87B(4),W87B(5),W87B(6),W87B(7),
     *  W87B(8),W87B(9),W87B(10),W87B(11),W87B(12),W87B(13),W87B(14),
     *  W87B(15),W87B(16),W87B(17),W87B(18),W87B(19),W87B(20),W87B(21),
     *  W87B(22),W87B(23)/            2.741455637620724E-04,
     *     1.807124155057943E-03,     4.096869282759165E-03,
     *     6.758290051847379E-03,     9.549957672201647E-03,
     *     1.232944765224485E-02,     1.501044734638895E-02,
     *     1.754896798624319E-02,     1.993803778644089E-02,
     *     2.219493596101229E-02,     2.433914712600081E-02,
     *     2.637450541483921E-02,     2.828691078877120E-02,
     *     3.005258112809270E-02,     3.164675137143993E-02,
     *     3.305041341997850E-02,     3.425509970422606E-02,
     *     3.526241266015668E-02,     3.607698962288870E-02,
     *     3.669860449845609E-02,     3.712054926983258E-02,
     *     3.733422875193504E-02,     3.736107376267902E-02/
C           LIST OF MAJOR VARIABLES
C           -----------------------
C
C           CENTR  - MID POINT OF THE INTEGRATION INTERVAL
C           HLGTH  - HALF-LENGTH OF THE INTEGRATION INTERVAL
C           FCENTR - FUNCTION VALUE AT MID POINT
C           ABSC   - ABSCISSA
C           FVAL   - FUNCTION VALUE
C           SAVFUN - ARRAY OF FUNCTION VALUES WHICH HAVE ALREADY
C                    BEEN COMPUTED
C           RES10  - 10-POINT GAUSS RESULT
C           RES21  - 21-POINT KRONROD RESULT
C           RES43  - 43-POINT RESULT
C           RES87  - 87-POINT RESULT
C           RESABS - APPROXIMATION TO THE INTEGRAL OF ABS(F)
C           RESASC - APPROXIMATION TO THE INTEGRAL OF ABS(F-I/(B-A))
C
C           MACHINE DEPENDENT CONSTANTS
C           ---------------------------
C
C           EPMACH IS THE LARGEST RELATIVE SPACING.
C           UFLOW IS THE SMALLEST POSITIVE MAGNITUDE.
C           OFLOW IS THE LARGEST MAGNITUDE.
C
C***FIRST EXECUTABLE STATEMENT
      CALL QMACO(EPMACH,UFLOW,OFLOW)
C
C           TEST ON VALIDITY OF PARAMETERS
C           ------------------------------
C
      RESULT = 0.0E+00
      ABSERR = 0.0E+00
      NEVAL = 0
      IER = 6
      IF(EPSABS.LT.0.0E+00.AND.EPSREL.LT.0.0E+00) GO TO 999
      HLGTH = 5.0E-01*(B-A)
      DHLGTH = ABS(HLGTH)
      CENTR = 5.0E-01*(B+A)
      FCENTR = F(CENTR)
      NEVAL = 21
      IER = 1
C
C          COMPUTE THE INTEGRAL USING THE 10- AND 21-POINT FORMULA.
C
      DO 70 L = 1,3
      GO TO (5,25,45),L
    5 RES10 = 0.0E+00
      RES21 = W21B(6)*FCENTR
      RESABS = W21B(6)*ABS(FCENTR)
      DO 10 K=1,5
        ABSC = HLGTH*X1(K)
        FVAL1 = F(CENTR+ABSC)
        FVAL2 = F(CENTR-ABSC)
        FVAL = FVAL1+FVAL2
        RES10 = RES10+W10(K)*FVAL
        RES21 = RES21+W21A(K)*FVAL
        RESABS = RESABS+W21A(K)*(ABS(FVAL1)+ABS(FVAL2))
        SAVFUN(K) = FVAL
        FV1(K) = FVAL1
        FV2(K) = FVAL2
   10 CONTINUE
      IPX = 5
      DO 15 K=1,5
        IPX = IPX+1
        ABSC = HLGTH*X2(K)
        FVAL1 = F(CENTR+ABSC)
        FVAL2 = F(CENTR-ABSC)
        FVAL = FVAL1+FVAL2
        RES21 = RES21+W21B(K)*FVAL
        RESABS = RESABS+W21B(K)*(ABS(FVAL1)+ABS(FVAL2))
        SAVFUN(IPX) = FVAL
        FV3(K) = FVAL1
        FV4(K) = FVAL2
   15 CONTINUE
C
C          TEST FOR CONVERGENCE.
C
      RESULT = RES21*HLGTH
      RESABS = RESABS*DHLGTH
      RESKH = 5.0E-01*RES21
      RESASC = W21B(6)*ABS(FCENTR-RESKH)
      DO 20 K = 1,5
        RESASC = RESASC+W21A(K)*(ABS(FV1(K)-RESKH)+ABS(FV2(K)-RESKH))
     *                  +W21B(K)*(ABS(FV3(K)-RESKH)+ABS(FV4(K)-RESKH))
   20 CONTINUE
      ABSERR = ABS((RES21-RES10)*HLGTH)
      RESASC = RESASC*DHLGTH
      GO TO 65
C
C          COMPUTE THE INTEGRAL USING THE 43-POINT FORMULA.
C
   25 RES43 = W43B(12)*FCENTR
      NEVAL = 43
      DO 30 K=1,10
        RES43 = RES43+SAVFUN(K)*W43A(K)
   30 CONTINUE
      DO 40 K=1,11
        IPX = IPX+1
        ABSC = HLGTH*X3(K)
        FVAL = F(ABSC+CENTR)+F(CENTR-ABSC)
        RES43 = RES43+FVAL*W43B(K)
        SAVFUN(IPX) = FVAL
   40 CONTINUE
C
C          TEST FOR CONVERGENCE.
C
      RESULT = RES43*HLGTH
      ABSERR = ABS((RES43-RES21)*HLGTH)
      GO TO 65
C
C          COMPUTE THE INTEGRAL USING THE 87-POINT FORMULA.
C
   45 RES87 = W87B(23)*FCENTR
      NEVAL = 87
      DO 50 K=1,21
        RES87 = RES87+SAVFUN(K)*W87A(K)
   50 CONTINUE
      DO 60 K=1,22
        ABSC = HLGTH*X4(K)
        RES87 = RES87+W87B(K)*(F(ABSC+CENTR)+F(CENTR-ABSC))
   60 CONTINUE
      RESULT = RES87*HLGTH
      ABSERR = ABS((RES87-RES43)*HLGTH)
   65 IF(RESASC.NE.0.0E+00.AND.ABSERR.NE.0.0E+00)
     *  ABSERR = RESASC*AMIN1(1.0E+00,(2.0E+02*ABSERR/RESASC)**1.5E+00)
      IF (RESABS.GT.UFLOW/(5.0E+01*EPMACH)) ABSERR = AMAX1
     *  ((EPMACH*5.0E+01)*RESABS,ABSERR)
      IF (ABSERR.LE.AMAX1(EPSABS,EPSREL*ABS(RESULT))) IER = 0
C***JUMP OUT OF DO-LOOP
      IF (IER.EQ.0) GO TO 999
   70 CONTINUE
  999 RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE QMACO(EPMACH,UFLOW,OFLOW)
C
C.......................................................................
C
C   QMACO IS A MACHINE DEPENDENT SUBROUTINE, PROVIDING THE MACHINE
C   CONSTANTS TO THE QUADPACK ROUTINES
C
C   PARAMETERS
C       ON RETURN
C        EPMACH   - THE LARGEST RELATIVE SPACING
C        UFLOW    - THE SMALLEST POSITIVE MAGNITUDE
C        OFLOW    - THE LARGEST POSITIVE MAGNITUDE
C
C.......................................................................
C
      REAL EPMACH,OFLOW,UFLOW
C
C   MACHINE CONSTANTS FOR PDP-11
C
      EPMACH = 1.0E-7
      UFLOW = 1.0E-37
      OFLOW = 1.0E+38
      RETURN
      END
C==================================================